#include <iostream>
#include <vector>

using namespace std;

long long calcSum(vector<int[3]>& e, int x) {
    long long ans = 0;

    for(int i = 0; i < e.size(); ++i) {
        ans += min(e[i][0], x) * e[i][1] + max(0, x - e[i][0]) * e[i][2];
    }

    return ans;
}

long long calcAns(vector<int[3]>& e, int x, long long p) {
    long long k = 0;
    long long r = 0;

    for(int i = 0; i < e.size(); ++i) {
        if(e[i][0] >= x) {
            k += e[i][1];
        } else {
            k += e[i][2];
            r += e[i][0] * e[i][1] - e[i][0] * e[i][2];
        }
    }

    return (p - r + k - 1) / k;
}

int main() {
    long long n, p;
    cin >> n >> p;

    vector<int[3]> engines(n);

    for(int i = 0; i < n; ++i) {
        cin >> engines[i][0] >> engines[i][1] >> engines[i][2];
    }

    int segmentNum = 0;

    for(int i = 0; i < n; ++i) {
        if(calcSum(engines, engines[i][0]) >= p) {
            break;
        }

        ++segmentNum;
    }

    if(segmentNum == n) {
        cout << calcAns(engines, 1e9 + 1, p);
    } else {
        cout << calcAns(engines, engines[segmentNum][0], p);
    }

    return 0;
}
