#include <iostream>
#include <vector>

using namespace std;

unsigned long long calcSum(vector<long long[3]>& e, long long x) {
    unsigned long long ans = 0;

    for(int i = 0; i < e.size(); ++i) {
        ans += min(e[i][0], x) * e[i][1] + max((long long)0, x - e[i][0]) * e[i][2];
    }

    return ans;
}

unsigned long long calcAns(vector<long long[3]>& e, long long x, long long p) {
    unsigned long long k = 0;
    long long r = 0;

    for(int i = 0; i < e.size(); ++i) {
        if(e[i][0] >= x) {
            k += e[i][1];
        } else {
            k += e[i][2];
            r += e[i][0] * e[i][1] - e[i][0] * e[i][2];
        }
    }

    if(r < 0) {
        return (p + (unsigned long long)abs(r) + k - (unsigned long long)1) / k;
    } else {
        return (p - (unsigned long long)abs(r) + k - (unsigned long long)1) / k;
    }

}

int main() {
    unsigned long long n, p;
    cin >> n >> p;

    vector<long long[3]> engines(n);

    for(int i = 0; i < n; ++i) {
        cin >> engines[i][0] >> engines[i][1] >> engines[i][2];
    }

    int segmentNum = 0;

    for(int i = 0; i < n; ++i) {
        if(calcSum(engines, engines[i][0]) >= p) {
            break;
        }

        ++segmentNum;
    }

    if(segmentNum == n) {
        cout << calcAns(engines, 1e9 + 1, p);
    } else {
        cout << calcAns(engines, engines[segmentNum][0], p);
    }

    return 0;
}
