#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

unsigned long long calcSum(vector<pair<long long, pair<long long, long long>>>& e, long long x) {
    unsigned long long ans = 0;

    for(int i = 0; i < e.size(); ++i) {
        ans += min(e[i].first, x) * e[i].second.first + max((long long)0, x - e[i].first) * e[i].second.second;
    }

    return ans;
}

long long calcAns(vector<pair<long long, pair<long long, long long>>>& e, long long x, long long p) {
    long long k = 0;
    long long r = 0;

    for(int i = 0; i < e.size(); ++i) {
        if(e[i].first >= x) {
            k += e[i].second.first;
        } else {
            k += e[i].second.second;
            r += e[i].first * e[i].second.first - e[i].first * e[i].second.second;
        }
    }

    if(r < 0) {
        return (p + (long long)abs(r) + k - (long long)1) / k;
    } else {
        return (p - (long long)abs(r) + k - (long long)1) / k;
    }

}

bool comp(const long long a[3], const long long b[3]) {
    if(a[2] < b[2]) {
        return true;
    }

    return false;
}

int main() {
    long long n, p;
    cin >> n >> p;

    vector<pair<long long, pair<long long, long long>>> engines(n);

    for(int i = 0; i < n; ++i) {
        cin >> engines[i].first >> engines[i].second.first >> engines[i].second.second;
    }

    sort(engines.begin(), engines.end());

    int segmentNum = 0;

    for(int i = 0; i < n; ++i) {
        if(calcSum(engines, engines[i].first) >= p) {
            break;
        }

        ++segmentNum;
    }

    if(segmentNum == n) {
        cout << calcAns(engines, 1e9 + 1, p);
    } else {
        cout << calcAns(engines, engines[segmentNum].first, p);
    }

    return 0;
}
